/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.server.dao;

import java.util.Collection;

import org.appspy.server.bo.Dashboard;
import org.appspy.server.bo.Report;
import org.appspy.server.bo.ReportCategory;
import org.appspy.server.bo.ReportParamChooser;
import org.appspy.server.bo.ReportingSystem;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public interface ReportDao {

	public ReportCategory saveReportCategory(ReportCategory cat);
	public ReportCategory updateReportCategory(ReportCategory cat);
	public void removeReportCategory(ReportCategory cat);
	public ReportCategory findReportCategoryById(Long catId);
	public ReportCategory findReportCategoryByName(String catName);
	public Collection<ReportCategory> findAllReportCategories();
	
	public Report saveReport(Report report);
	public Report updateReport(Report report);
	public void removeReport(Report report);
	public Report findReportById(Long reportId);
	public Report findReportByName(String reportName);
	public Collection<Report> findAllReports();
	
	public Dashboard saveDashboard(Dashboard dashboard);
	public Dashboard updateDashboard(Dashboard dashboard);
	public void removeDashboard(Dashboard dashboard);
	public Dashboard findDashboardById(Long dashboardId);
	public Dashboard findDashboardByName(String name);
	public Collection<Dashboard> findAllDashboards();
	
	public ReportingSystem saveReportingSystem(ReportingSystem sys);
	public ReportingSystem findReportingSystemById(Long sysId);
	public ReportingSystem findReportingSystemByName(String sysName);
	public Collection<ReportingSystem> findAllReportingSystems();
	
	public ReportParamChooser saveReportParamChooser(ReportParamChooser chooser);
	public ReportParamChooser findReportParamChooserById(Long chooserId);
	public ReportParamChooser findReportParamChooserByName(String chooserName);
	public Collection<ReportParamChooser> findAllReportParamChoosers();
}
