/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.server.dao.xml;

import org.appspy.server.bo.HitResult;
import org.appspy.server.dao.PerfDao;
import org.appspy.server.xml.XmlHitResult;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class XmlHitResultDataLoader implements XmlDataLoader {
	
	protected PerfDao mPerfDao = null;

	/* (non-Javadoc)
	 * @see org.appspy.server.dao.xml.XmlDataLoader#loadData(java.util.Collection)
	 */
	public void loadData(Object data) {
		XmlHitResult xhr = (XmlHitResult) data;
		
		HitResult hr = mPerfDao.findHitResultByValue(xhr.getValue());
		if (hr == null)
		{
			hr = new HitResult();
			hr.setCode(xhr.getCode());
			hr.setValue(xhr.getValue());
			mPerfDao.saveHitResult(hr);
		}
	}

	/**
     * @return the perfDao
     */
    public PerfDao getPerfDao()
    {
    	return mPerfDao;
    }

	/**
     * @param perfDao the perfDao to set
     */
    public void setPerfDao(PerfDao perfDao)
    {
    	mPerfDao = perfDao;
    }

}
