/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License.
 *  
 * You may obtain a copy of the License at 
 * 	http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.server.dao.xml;

import org.appspy.server.bo.ReportCategory;
import org.appspy.server.dao.ReportDao;
import org.appspy.server.xml.XmlReportCategory;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class XmlReportCategoryDataLoader implements XmlDataLoader {
	
	protected ReportDao mReportDao = null;

	/* (non-Javadoc)
	 * @see org.appspy.server.dao.xml.XmlDataLoader#loadData(java.util.Collection)
	 */
	public void loadData(Object data) {
		XmlReportCategory xrc = (XmlReportCategory) data;
		
		ReportCategory rc = mReportDao.findReportCategoryByName(xrc.getName());
		if (rc == null)
		{
			rc = new ReportCategory();
			rc.setName(xrc.getName());
			mReportDao.saveReportCategory(rc);
		}
	}

	/**
	 * @return the reportDao
	 */
	public ReportDao getReportDao() {
		return mReportDao;
	}

	/**
	 * @param reportDao the reportDao to set
	 */
	public void setReportDao(ReportDao reportDao) {
		mReportDao = reportDao;
	}

	
}
